# coding: utf-8

"""
    Cythereal Dashboard API

     The API used exclusively by the MAGIC Dashboard for populating charts, graphs, tables, etc... on the dashboard.  # API Conventions  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/alerts` endpoint should return a response object with `data.alerts`. This property SHOULD  contain a list of the returned objects. For the `/alerts` endpoint, the `data.alerts` property contains a list of MagicAlerts objects. See the `/alerts` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `success` | MUST equal False.   # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@cythereal.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class FilesListFiles(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sha1': 'str',
        'sha256': 'str',
        'sha512': 'str',
        'md5': 'str',
        'object_class': 'str',
        'unix_filetype': 'str',
        'upload_date': 'str',
        'filenames': 'list[str]',
        'tags': 'list[str]',
        'status': 'str',
        'analysis': 'list[BinaryTableModelAnalysis]'
    }

    attribute_map = {
        'sha1': 'sha1',
        'sha256': 'sha256',
        'sha512': 'sha512',
        'md5': 'md5',
        'object_class': 'object_class',
        'unix_filetype': 'unix_filetype',
        'upload_date': 'upload_date',
        'filenames': 'filenames',
        'tags': 'tags',
        'status': 'status',
        'analysis': 'analysis'
    }

    def __init__(self, sha1=None, sha256=None, sha512=None, md5=None, object_class=None, unix_filetype=None, upload_date=None, filenames=None, tags=None, status=None, analysis=None):  # noqa: E501
        """FilesListFiles - a model defined in Swagger"""  # noqa: E501

        self._sha1 = None
        self._sha256 = None
        self._sha512 = None
        self._md5 = None
        self._object_class = None
        self._unix_filetype = None
        self._upload_date = None
        self._filenames = None
        self._tags = None
        self._status = None
        self._analysis = None
        self.discriminator = None

        if sha1 is not None:
            self.sha1 = sha1
        if sha256 is not None:
            self.sha256 = sha256
        if sha512 is not None:
            self.sha512 = sha512
        if md5 is not None:
            self.md5 = md5
        if object_class is not None:
            self.object_class = object_class
        if unix_filetype is not None:
            self.unix_filetype = unix_filetype
        if upload_date is not None:
            self.upload_date = upload_date
        if filenames is not None:
            self.filenames = filenames
        if tags is not None:
            self.tags = tags
        if status is not None:
            self.status = status
        if analysis is not None:
            self.analysis = analysis

    @property
    def sha1(self):
        """Gets the sha1 of this FilesListFiles.  # noqa: E501

        A SHA1 cryptographic hash  # noqa: E501

        :return: The sha1 of this FilesListFiles.  # noqa: E501
        :rtype: str
        """
        return self._sha1

    @sha1.setter
    def sha1(self, sha1):
        """Sets the sha1 of this FilesListFiles.

        A SHA1 cryptographic hash  # noqa: E501

        :param sha1: The sha1 of this FilesListFiles.  # noqa: E501
        :type: str
        """
        if sha1 is not None and not re.search(r'[a-fA-F0-9]{40}', sha1):  # noqa: E501
            raise ValueError(r"Invalid value for `sha1`, must be a follow pattern or equal to `/[a-fA-F0-9]{40}/`")  # noqa: E501

        self._sha1 = sha1

    @property
    def sha256(self):
        """Gets the sha256 of this FilesListFiles.  # noqa: E501

        A SHA256 cryptographic hash  # noqa: E501

        :return: The sha256 of this FilesListFiles.  # noqa: E501
        :rtype: str
        """
        return self._sha256

    @sha256.setter
    def sha256(self, sha256):
        """Sets the sha256 of this FilesListFiles.

        A SHA256 cryptographic hash  # noqa: E501

        :param sha256: The sha256 of this FilesListFiles.  # noqa: E501
        :type: str
        """
        if sha256 is not None and not re.search(r'[a-fA-F0-9]{64}', sha256):  # noqa: E501
            raise ValueError(r"Invalid value for `sha256`, must be a follow pattern or equal to `/[a-fA-F0-9]{64}/`")  # noqa: E501

        self._sha256 = sha256

    @property
    def sha512(self):
        """Gets the sha512 of this FilesListFiles.  # noqa: E501

        A SHA512 cryptographic hash  # noqa: E501

        :return: The sha512 of this FilesListFiles.  # noqa: E501
        :rtype: str
        """
        return self._sha512

    @sha512.setter
    def sha512(self, sha512):
        """Sets the sha512 of this FilesListFiles.

        A SHA512 cryptographic hash  # noqa: E501

        :param sha512: The sha512 of this FilesListFiles.  # noqa: E501
        :type: str
        """
        if sha512 is not None and not re.search(r'[a-fA-F0-9]{128}', sha512):  # noqa: E501
            raise ValueError(r"Invalid value for `sha512`, must be a follow pattern or equal to `/[a-fA-F0-9]{128}/`")  # noqa: E501

        self._sha512 = sha512

    @property
    def md5(self):
        """Gets the md5 of this FilesListFiles.  # noqa: E501

        A MD5 cryptographic hash  # noqa: E501

        :return: The md5 of this FilesListFiles.  # noqa: E501
        :rtype: str
        """
        return self._md5

    @md5.setter
    def md5(self, md5):
        """Sets the md5 of this FilesListFiles.

        A MD5 cryptographic hash  # noqa: E501

        :param md5: The md5 of this FilesListFiles.  # noqa: E501
        :type: str
        """
        if md5 is not None and not re.search(r'[a-fA-F0-9]{32}', md5):  # noqa: E501
            raise ValueError(r"Invalid value for `md5`, must be a follow pattern or equal to `/[a-fA-F0-9]{32}/`")  # noqa: E501

        self._md5 = md5

    @property
    def object_class(self):
        """Gets the object_class of this FilesListFiles.  # noqa: E501

        The object_class of the file. See  http://docs.cythereal.com/en/v0/src/usage_guide/query.html#file-object-classes  for more details  # noqa: E501

        :return: The object_class of this FilesListFiles.  # noqa: E501
        :rtype: str
        """
        return self._object_class

    @object_class.setter
    def object_class(self, object_class):
        """Sets the object_class of this FilesListFiles.

        The object_class of the file. See  http://docs.cythereal.com/en/v0/src/usage_guide/query.html#file-object-classes  for more details  # noqa: E501

        :param object_class: The object_class of this FilesListFiles.  # noqa: E501
        :type: str
        """

        self._object_class = object_class

    @property
    def unix_filetype(self):
        """Gets the unix_filetype of this FilesListFiles.  # noqa: E501

        Output of the unix `file` command for the file.  # noqa: E501

        :return: The unix_filetype of this FilesListFiles.  # noqa: E501
        :rtype: str
        """
        return self._unix_filetype

    @unix_filetype.setter
    def unix_filetype(self, unix_filetype):
        """Sets the unix_filetype of this FilesListFiles.

        Output of the unix `file` command for the file.  # noqa: E501

        :param unix_filetype: The unix_filetype of this FilesListFiles.  # noqa: E501
        :type: str
        """

        self._unix_filetype = unix_filetype

    @property
    def upload_date(self):
        """Gets the upload_date of this FilesListFiles.  # noqa: E501

        Date the file was originally uploaded.  # noqa: E501

        :return: The upload_date of this FilesListFiles.  # noqa: E501
        :rtype: str
        """
        return self._upload_date

    @upload_date.setter
    def upload_date(self, upload_date):
        """Sets the upload_date of this FilesListFiles.

        Date the file was originally uploaded.  # noqa: E501

        :param upload_date: The upload_date of this FilesListFiles.  # noqa: E501
        :type: str
        """

        self._upload_date = upload_date

    @property
    def filenames(self):
        """Gets the filenames of this FilesListFiles.  # noqa: E501


        :return: The filenames of this FilesListFiles.  # noqa: E501
        :rtype: list[str]
        """
        return self._filenames

    @filenames.setter
    def filenames(self, filenames):
        """Sets the filenames of this FilesListFiles.


        :param filenames: The filenames of this FilesListFiles.  # noqa: E501
        :type: list[str]
        """

        self._filenames = filenames

    @property
    def tags(self):
        """Gets the tags of this FilesListFiles.  # noqa: E501


        :return: The tags of this FilesListFiles.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this FilesListFiles.


        :param tags: The tags of this FilesListFiles.  # noqa: E501
        :type: list[str]
        """

        self._tags = tags

    @property
    def status(self):
        """Gets the status of this FilesListFiles.  # noqa: E501

        The overall processing status of the file  # noqa: E501

        :return: The status of this FilesListFiles.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this FilesListFiles.

        The overall processing status of the file  # noqa: E501

        :param status: The status of this FilesListFiles.  # noqa: E501
        :type: str
        """

        self._status = status

    @property
    def analysis(self):
        """Gets the analysis of this FilesListFiles.  # noqa: E501


        :return: The analysis of this FilesListFiles.  # noqa: E501
        :rtype: list[BinaryTableModelAnalysis]
        """
        return self._analysis

    @analysis.setter
    def analysis(self, analysis):
        """Sets the analysis of this FilesListFiles.


        :param analysis: The analysis of this FilesListFiles.  # noqa: E501
        :type: list[BinaryTableModelAnalysis]
        """

        self._analysis = analysis

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(FilesListFiles, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FilesListFiles):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
